
QGIS Application - Bug report #2339

QGis crashes when moving border between map canvas and overview map and "use render 

caching..." enabled

2010-01-02 12:17 PM - kivih1 -

Status: Closed

Priority: Low

Assignee:

Category: Map Canvas

Affected QGIS version: Regression?: No

Operating System: All Easy fix?: No

Pull Request or Patch supplied: Resolution: duplicate

Crashes QGIS or corrupts data: Copied to github as #: 12399

Description

when there are layers in the project and one or more layers is visible, and the Overview map is visible and docked (left or right), QGis

crashes when trying to move the border between the canvas and the overview map. It is not necessary to have layers associated with the

overview map for the program to crash.

History

#1 - 2010-01-02 12:54 PM - Jürgen Fischer

no reproducable with commit:8545ed7e (SVN r12664) here.

#2 - 2010-01-03 01:09 AM - Giovanni Manghi

Tested under linux and windows, both with qgis 1.4 and trunk, overview window docked on both sides. Not reproducable here.

#3 - 2010-01-04 01:55 PM - kivih1 -

this is strange: I can't reproduce it on my computer at work, but it's still there on my private computer (which is only 3 months old). Maybe it has to do with

the graphica card? Anyway, the very same project loaded in Qgis 1.3 behaves OK, whereas it crashes in 1.4.

I will do some more experimentation in the coming weeks, and will report when I have any news.

Hubert

#4 - 2010-01-05 11:25 AM - Giovanni Manghi

Hi,

it would be great to see what the console returns when qgis crashes. Do you have any linux installation in your pc?

#5 - 2010-01-05 12:42 PM - kivih1 -

Lutra,

I don't have Linux on my PC. This is what info I get from Windows after the crash:

Error signature: see jpg in the appendix 
Exception information (the first part of it, too large to show all): see jpg 

Additional information added to the error report: see txt

It all makes no sense to me but I hope it does so to you!

Hubert

#6 - 2010-01-21 02:11 AM - Giovanni Manghi

Still not able to replicate this on both windows (xp) and linux. Can you replicate the problem on more than one machine, in order to rule out local

configuration problems?

#7 - 2010-01-26 08:58 AM - kivih1 -

I found out that Qgis only crashes when Actions->Options->Use cache when rendering is turned ON. When OFF no problems.

Hubert

#8 - 2010-01-26 09:08 AM - Giovanni Manghi

Ok, this is confirmed also under linux.

Terminal says

"Warning: QPaintDevice: Cannot destroy paint device that is being painted

Segmentation fault" 

#9 - 2010-05-30 01:52 PM - Jürgen Fischer

might be related to #2714.

#10 - 2010-06-09 12:19 AM - Giovanni Manghi

Replying to [comment:11 jef]:

might be related to #2714.

if the workaround for #2714 has fixed it then it does not work for this bug. It is pretty easy to reproduce on trunk but I also found vectors that do not cause

qgis to crash.

#11 - 2010-06-13 11:03 PM - Alister Hood

Replying to [comment:12 lutra]:

Replying to [comment:11 jef]:
might be related to #2714.

if the workaround for #2714 has fixed it then it does not work for this bug. It is pretty easy to reproduce on trunk but I also found vectors that do not

cause qgis to crash.

I've just installed 1.5 and am unable to reproduce.  N.B. that for me 1.4 only crashed sometimes - not every time I moved the border.

#12 - 2010-07-25 03:48 AM - Giuseppe Sucameli

Unable to reproduce it using QGis trunk (commit:0d74e285 (SVN r13959)) on Ubuntu 9.04

#13 - 2010-07-25 08:27 AM - Giovanni Manghi

Replying to [comment:15 brushtyler]:

Unable to reproduce it using QGis trunk (commit:0d74e285 (SVN r13959)) on Ubuntu 9.04

Hi Giuseppe,

it is not replicable with all vectors. I also found vectors that do not cause the crash.

#14 - 2010-07-25 08:32 AM - Giuseppe Sucameli

Replying to [comment:16 lutra]:

Replying to [comment:15 brushtyler]:

Unable to reproduce it using QGis trunk (commit:0d74e285 (SVN r13959)) on Ubuntu 9.04

Hi Giuseppe,

it is not replicable with all vectors. I also found vectors that do not cause the crash.

I tried more than one vector but nothing.

Could you attach a vector file which may cause the crash?

#15 - 2010-07-25 08:54 AM - Giovanni Manghi

With this

http://www.iambiente.pt/atlas/dl/regista_dl.jsp?zona=continente&#38;grupo=&#38;tema=c_curvasnivel

for me is instant crash even with "Use cache when rendering" OFF.

I'm using qgis 1.5 under Ubuntu 10.04

2024-04-09 3/6

http://www.iambiente.pt/atlas/dl/regista_dl.jsp?zona=continente&#38;grupo=&#38;tema=c_curvasnivel


gio@sibirica:~$ qgis

Python support ENABLED :-) 

Loaded : [[GdalTools]] (package: [[GdalTools]])

Warning: QHttp: empty path requested is invalid -- using '/'

Loaded : Plugin Installer (package: plugin_installer)

Loaded : fTools (package: fTools)

Loaded : [[OpenStreetMap]] plugin (package: osm)

Loaded : [[MapServer]] Export (package: mapserver_export)

gio@sibirica:~$ qgis

Python support ENABLED :-) 

Loaded : [[GdalTools]] (package: [[GdalTools]])

Warning: QHttp: empty path requested is invalid -- using '/'

Loaded : Plugin Installer (package: plugin_installer)

Loaded : fTools (package: fTools)

Loaded : [[OpenStreetMap]] plugin (package: osm)

Loaded : [[MapServer]] Export (package: mapserver_export)

Warning: QPixmap::operator=: Cannot assign to pixmap during painting

Warning: QPainter::begin: A paint device can only be painted by one painter at a time.

Warning: QPainter::end: Painter not active, aborted

Warning: QPixmap::operator=: Cannot assign to pixmap during painting

Warning: QPainter::begin: A paint device can only be painted by one painter at a time.

Warning: QPainter::end: Painter not active, aborted

Warning: QPixmap::operator=: Cannot assign to pixmap during painting

Warning: QPainter::begin: A paint device can only be painted by one painter at a time.

Warning: QPainter::end: Painter not active, aborted

Warning: QPixmap::operator=: Cannot assign to pixmap during painting

Warning: QPainter::begin: A paint device can only be painted by one painter at a time.

Warning: QPainter::end: Painter not active, aborted

Warning: QPixmap::operator=: Cannot assign to pixmap during painting

Warning: QPainter::begin: A paint device can only be painted by one painter at a time.

Warning: QPainter::end: Painter not active, aborted

Segmentation fault

#16 - 2010-07-25 09:10 AM - Giuseppe Sucameli

Ok, now I'm able to reproduce it too (QGis trunk commit:0d74e285 (SVN r13959) on Ubuntu 9.04)

#17 - 2010-07-27 09:23 AM - Giuseppe Sucameli

Replying to [comment:18 lutra]:

With this

http://www.iambiente.pt/atlas/dl/regista_dl.jsp?zona=continente&#38;grupo=&#38;tema=c_curvasnivel

for me is instant crash even with "Use cache when rendering" OFF.

For me only if the cache render is enabled.
Before crash, the terminal displays this message:

"Warning: QPaintDevice: Cannot destroy paint device that is being painted

Segmentation fault" 

This message is displayed from

/home/brushtyler/Projects/Work/Faunalia/qgis/qgis_unstable/src/core/qgsmaplayer.cpp: 848

delete mpCacheImage;

So I think that when the render is disabled the crash is related to a different issue.

#18 - 2010-10-23 01:15 AM - Paolo Cavallini

Might be due to Qt? Could you please try again with current trunk, and report which Qt version you use?

#19 - 2010-10-26 12:06 PM - Giovanni Manghi

tested again with trunk, on ubuntu 10.04 and 10.10 (different libqt4 versions), render caching on and off and it is always instant crash.

#20 - 2011-01-13 03:52 PM - Giuseppe Sucameli

Replying to [comment:23 lutra]:

tested again with trunk, on ubuntu 10.04 and 10.10 (different libqt4 versions), render caching on and off and it is always instant crash.

I made further tests. I found that segfault is dued to the processEvent() calls in [[QgsVectorLayer]] (!QgsVectorLayer.cpp:1045).

Searching for similar Qt bugs, I found #2714 (maybe the same bug??), and also Martin wrote the problem is caused by processEvent(). The crash

happens in Qt libraries.

I discovered another piece, it's caused by an invalid extra-call. If I add debug messages both before (!QgsVectorLayer.cpp:1039) and after

(!QgsVectorLayer.cpp:1055) the qapp->processEvent() call I notice that there are N pre-call messages and N+1 post-call messages.

#21 - 2011-01-13 04:03 PM - Giuseppe Sucameli

Replying to [comment:24 brushtyler]:

I discovered another piece, it's caused by an invalid extra-call. If I add debug messages both before (!QgsVectorLayer.cpp:1039) and after

(!QgsVectorLayer.cpp:1055) the qapp->processEvent() call I notice that there are N pre-call messages and N+1 post-call messages.

Found, no extra-call (would be very strange!), but it's a race condition, see the attachment.
#22 - 2011-01-13 04:08 PM - Giuseppe Sucameli

Look at the attachment qgis_ticket_2339_bt:

at line 95 you can see the missing "before qApp->processEvents()"

and after a refreshing of the layer

at line 189 there's the related "after qApp->processEvents()"

#23 - 2011-01-14 03:33 PM - Jürgen Fischer

- Status changed from Open to Closed

- Resolution set to duplicate

duplicate of #2714.

Files

5c5e_appcompat.txt 9.77 KB 2010-01-05 kivih1 -

error_signature.jpg 10.2 KB 2010-01-05 kivih1 -

Exception_information1.jpg 228 KB 2010-01-05 kivih1 -

qgis_ticket_2339_bt 29.6 KB 2011-01-13 Giuseppe Sucameli
